#include "config.h"
#include "vbus.h"
#include "nrg_meter.h"
#include <avr/io.h>

#ifndef _ENERGY_H_
#define _ENERGY_H_

#define NRG_METER_CNT 4

//Haupttarif/Nebentarif
#define NRG_WP_PEAK_DDR DDRC
#define NRG_WP_PEAK_REG PINC
#define NRG_WP_PEAK_PIN (1<<PC3)

//Stromversorgung der WP
#define NRG_WP_PWR_DDR DDRC
#define NRG_WP_PWR_REG PINC
#define NRG_WP_PWR_PIN (1<<PC4)

//Druckwarnung Solaranlage
/*#define NRG_SOLAR_LOWP_DDR DDRC
#define NRG_SOLAR_LOWP_REG PINC
#define NRG_SOLAR_LOWP_PIN (1<<PC5)*/


typedef struct {
	unsigned long starttime;
	volatile t_vbus_outdata solar;
	uint16_t meter[NRG_METER_CNT];
	uint16_t air_pressure;
	unsigned wp_ht:1;
	unsigned wp_pwr:1;
	unsigned solar_lowpressure:1;
} t_nrg_stats;

volatile uint16_t nrg_timer;

volatile t_nrg_stats energy_stats[NRG_LOG_COUNT];
volatile t_nrgmtr nrg_meters[NRG_METER_CNT];

extern volatile t_vbus_outdata c_solar;

extern volatile uint16_t nrg_timer;
extern volatile uint8_t nrg_ticks;
extern volatile uint8_t c_wp_ht;


extern void nrg_init();
extern void nrg_mainloop();

extern void nrg_put_http(uint8_t type, uint8_t index, uint8_t packetindex);

#endif
