#include "hwui.h"


#include "config.h"
#include "fleury_lcd.h"
#include "ntp.h"
#include "energy.h"
#include "timer.h"
#include "analog.h"





#define SCROLLER_UP (508/4)
#define SCROLLER_DOWN (934/4)
#define SCROLLER_TOLERANCE 10
#define SCROLLER_VALUE (advals[5]/4)

uint8_t curscreen = 1;
int8_t scroller_last = -1;
int8_t scroller_val;


int8_t GetScroll() {
	if(SCROLLER_VALUE > (SCROLLER_DOWN - SCROLLER_TOLERANCE) && SCROLLER_VALUE < (SCROLLER_DOWN + SCROLLER_TOLERANCE)) {
		scroller_val = 1;
	} else if(SCROLLER_VALUE > (SCROLLER_UP - SCROLLER_TOLERANCE) && SCROLLER_VALUE < (SCROLLER_UP + SCROLLER_TOLERANCE)) {
		scroller_val = -1;
	} else {
		scroller_val = 0;
	}

	if(scroller_val != scroller_last) {
		scroller_last = scroller_val;
		return scroller_val;
	}
	scroller_last = scroller_val;
	return 0;

}

void ui_refresh() {
	int8_t scroll = GetScroll();
	if(scroll != 0) {
		curscreen += scroll;
		if(curscreen == 5) { curscreen = 1; }
		if(curscreen == 0) { curscreen = 4; }
		tmr_backlight = 15;
		lcd_clrscr();
	}
	
	if(tmr_backlight > 0) lcd_backlight(1);
	if(tmr_backlight == 0) lcd_backlight(0);
	
	lcd_print(0, 15, "%i", curscreen);
	
	if(curscreen == 1) {
		lcd_print(0, 0, "=== Zeit ===");
	
		ntp_struct dt;
		decode_time(time, &dt);
		lcd_print(2, 0, "%s", dt.datestr);
		lcd_print(3, 0, "%s", dt.timestr);
	
	} else if(curscreen == 2) {
		lcd_print(0, 0, "=== Strom ===");
		
		lcd_print(1,0, "HZ:");
	
		uint16_t time = nrg_meters[0].letzt_umlauf;
		if(time < nrg_meters[0].umlaufzeit) {
			time = nrg_meters[0].umlaufzeit;
			lcd_putc('<');
		} else {
			lcd_putc(' ');
		}
	
		lcd_print(-1,-1, "%5iW  ", nrgmtr_verbrauch(time, 10, 75)); //Hauptzhler
	
	
		lcd_print(2,0, "WP:");
	
		uint8_t idx = (c_wp_ht == 1) ? 1 : 2;
	
		time = nrg_meters[idx].letzt_umlauf;
		if(time < nrg_meters[idx].umlaufzeit) {
			time = nrg_meters[idx].umlaufzeit;
			lcd_putc('<');
		} else {
			lcd_putc(' ');
		}
	
	
		lcd_print(-1,-1, "%5iW ", nrgmtr_verbrauch(time, 10, 75)); //Wrmepumpe
		if(c_wp_ht == 1) {
			lcd_puts("HT");
		} else {
			lcd_puts("NT");
		}
		lcd_puts("  ");
	} else if(curscreen == 3) {
		lcd_print(0, 0, "=== Solar ===");
		
		
		lcd_print(1, 0, "Koll: %3iC", c_solar.temp[0]/10);
		lcd_print(2, 0, "Pump: %3i->%3i", c_solar.pump[0], c_solar.pump[1]);
		lcd_print(3, 0, "Spei: %2iC o:%2iC", c_solar.temp[2]/10, c_solar.temp[6]/10);
	} else if(curscreen == 4) {
		lcd_print(0, 0, "=== Debug ===");
	
		lcd_print(1, 0, "Stack: %4is", WTT - stack_watchdog);
		lcd_print(2, 0, "NTPup: %4is", ntp_resync);
//		lcd_print(3, 0, "Pull:  %4is", nrg_pull);
	}
}
