#ifndef _H_NRG_METER
#define _H_NRG_METER

#include <avr/io.h>

#define JSON_NRGMTR_REPORTS 1

typedef struct {
	uint16_t umlaeufe;
	uint16_t umlaufzeit;
	uint16_t letzt_umlauf;
	uint8_t mask;
	volatile unsigned char *in_reg;
	uint8_t in_pin;
} t_nrgmtr;

extern void nrgmtr_init(t_nrgmtr* z, volatile unsigned char *in_ddr, volatile unsigned char *in_reg, uint8_t in_pin);
extern uint8_t nrgmtr_check(t_nrgmtr* z);
extern void nrgmtr_tick(t_nrgmtr* z, uint8_t time);
extern uint16_t nrgmtr_verbrauch(uint16_t umlauf, uint8_t timerfreq, uint8_t rotperkwh);
extern uint8_t nrgmtr_ToJson(t_nrgmtr *data, char *ptr);
#endif
